//pragma JS
manager.bStats("mutiBackpack","1.0.1","superice666",8326);
var worldconfigtext = manager.readFile("./plugins/mutiBackpack/groups.json")
if(worldconfigtext=="FILE NOT FOUND"){
    worldconfigtext = manager.formatJSON(JSON.stringify({
        "groups":[
            {
                "name":"test",
                "worlds": ["world"]
            }
        ],
        "played":[]
    }));
    manager.writeFile("./plugins/mutiBackpack/groups.json",worldconfigtext);
} 
var worldconfig = JSON.parse(worldconfigtext);
manager.createLoopTask("autoSave",100);
function autoSave(tick){
    let pls = server.getOnlinePlayers().values().toArray()
    for(let i=0;i<pls.length;i++){
        Bag2String(pls[i],getGroup(pls[i].getLevel().getName()));
    }
}
function getGroup(worldname){
    for(let i=0;i<worldconfig['groups'].length;i++){
        for(let j=0;j<worldconfig['groups'][i]["worlds"].length;j++){
            if(worldname == worldconfig['groups'][i]["worlds"][j]){
                return worldconfig['groups'][i]["name"];
            }
        }
    }
    return "default";
}
function hasJoinedBefore(player){
    for(let i=0;i<worldconfig["played"].length;i++){
        if(worldconfig["played"][i]==player.getName()){
            return true;
        }
    }
    return false;
}
function PlayerJoinEvent(event){
    if(hasJoinedBefore(event.getPlayer())){
        String2Bag(event.getPlayer(),getGroup(event.getPlayer().getLevel().getName()));
    }else{
        Bag2String(event.getPlayer(),getGroup(event.getPlayer().getLevel().getName()));
        worldconfig["played"].push(event.getPlayer().getName());
        manager.writeFile("./plugins/mutiBackpack/groups.json",manager.formatJSON(JSON.stringify(worldconfig)));
    }
}
function PlayerQuitEvent(event){
    Bag2String(event.getPlayer(),getGroup(event.getPlayer().getLevel().getName()));
}
function PlayerTeleportEvent(event){
    if(event.getFrom().getLevel().getName()!=event.getTo().getLevel().getName()){
        window.forceClearWindow(event.getPlayer());
        let player = event.getPlayer();
        let craft1 = player.getUIInventory().getCraftingGrid().getItem(0).getId();
        let craft2 = player.getUIInventory().getCraftingGrid().getItem(1).getId();
        let craft3 = player.getUIInventory().getCraftingGrid().getItem(2).getId();
        let craft4 = player.getUIInventory().getCraftingGrid().getItem(3).getId();
        let cursor = player.getCursorInventory().getItem(0).getId();
        if(craft1!=0 || craft2!=0 || craft3!=0 || craft4!=0 || cursor!=0){
            event.setCancelled();
            manager.kickPlayer(player,"请勿尝试非法跨世界转移物品！");
            return;
        }
        Bag2String(event.getPlayer(),getGroup(event.getFrom().getLevel().getName()));
        String2Bag(event.getPlayer(),getGroup(event.getTo().getLevel().getName()));
    }
}
function PlayerRespawnEvent(event){
    String2Bag(event.getPlayer(),getGroup(event.getRespawnPosition().getLevel().getName()));
}
function PlayerDeathEvent(event){
    Bag2String(event.getEntity(),getGroup(event.getEntity().getLevel().getName()));
}
function Bag2String(player,group){
    let bjson = [];
    if(player==null){
        return;
    }
    let bagitems = inventory.getPlayerInv(player);
    for(let i=0;i<40;i++){
        let item = inventory.getInventorySlot(bagitems,i);
        if(item==null){
            item = blockitem.buildItem(0,0,1);
        }
        bjson[i]={"id":item.getId(),"count":item.getCount(),"data":item.getDamage(),"nbt":blockitem.getNBTString(item)}
    }
    manager.writeFile("./plugins/mutiBackpack/"+group+"/"+player.getName()+".json",JSON.stringify(bjson));
}
function String2Bag(player,group){
    let text = manager.readFile("./plugins/mutiBackpack/"+group+"/"+player.getName()+".json");
    if(text=="FILE NOT FOUND"){
        let inv = inventory.addInv(true,Java.to([],'cn.nukkit.item.Item[]'),'');
        inventory.setPlayerInv(player,inv);
        return;
    }
    let bjson = JSON.parse(text);
    let items = [];
    for(let i=0;i<bjson.length;i++){
        let tmp = blockitem.buildItem(bjson[i]["id"],bjson[i]["data"],bjson[i]["count"]);
        if(bjson[i]["nbt"]!=null){
           blockitem.putinNBTString(tmp,bjson[i]["nbt"]); 
        }
        items.push(tmp);
    }
    let inv = inventory.addInv(true,Java.to(items,'cn.nukkit.item.Item[]'),'');
    inventory.setPlayerInv(player,inv);
}